/* This Spaceshooter is an small space adventure game
 * Copyright (C) 2006,2007,2008  Christoph Egger
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ENEMY_H
#define ENEMY_H

//std - Include
#include <string>
#include <list>
#include <cstdio>

//projekt - include
#include "NPC.hpp"

#include "Player.hpp"

/** \brief Feindlicher NPC
  * \author Christoph Egger
  */
class CEnemy : 
	public ANPC
{
private:
	std::string m_powerupfile;

	CPlayer* m_player;

	void number_enemys(int* results, std::list<ANPC*>& r_active_my_enemys);

	bool calculate_y(float* down_up);

public:
	CEnemy(unsigned int starttime, int posx, int posy, Strength theStrength, std::string shipfile, std::string powerupfile, AI_parameter* parameter)
		: ANPC(starttime, posx, posy, theStrength, shipfile, parameter), m_powerupfile(powerupfile)
		{}

	std::string getPowerUp()
		{return m_powerupfile;}

	bool init(global_data_pointers Data, CPlayer* player, strength* Strength)
		{ m_player = player; return ANPC::init(Data, Strength);} 

	~CEnemy()
		{}
};


#endif
